%global dlrn_nvr python-openstackclient-4.0.2-2.20220427020028.54bf2c0
%global dlrn 1
%define upstream_version 4.0.2
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%global __python %{__python3}
%else
%global pyver 2
%global __python %{__python2}
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

# Command name
%global cname openstack

# library name
%global sname %{cname}client

%global with_doc 0

%global common_desc \
python-%{sname} is a unified command-line client for the OpenStack APIs. \
It is a thin wrapper to the stock python-*client modules that implement the \
actual REST API client actions.

Name:             python-%{sname}
Version: 4.0.2
Release: 2.20220427020029%{?dist}
Summary:          OpenStack Command-line Client

License:          ASL 2.0
URL:              http://launchpad.net/%{name}
Source0: python-openstackclient-4.0.2-2.20220427020028.54bf2c0.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=54bf2c054d7b8287de5cb20dfbf03af0383c29c9
Patch0001: 0001-Add-fields-parameter-to-ListPort-query.patch
Patch0002: 0002-compute-Add-server-group-create-rule-option.patch
Patch0003: 0003-Fix-reverted-osc-lib-interface-change.patch
Patch0004: 0004-compute-Reorder-building-of-columns-for-server-list.patch
Patch0005: 0005-compute-Show-flavor-in-server-list-with-API-2.47.patch
Patch0006: 0006-network-Make-network-qos-rule-create-type-option-req.patch
Patch0007: 0007-Add-bindep-file.patch
Patch0008: 0008-Fix-server-event-list-show-for-deleted-servers.patch
Patch0009: 0009-Allow-os-quota-list-query-to-filter-by-project.patch

BuildArch:        noarch

BuildRequires:    git
BuildRequires:    openstack-macros

%description
%{common_desc}

%package -n python%{pyver}-%{sname}
Summary:    OpenStack Command-line Client
%{?python_provide:%python_provide python%{pyver}-%{sname}}
%if %{pyver} == 3
Obsoletes: python2-%{sname} < %{version}-%{release}
%endif

BuildRequires:    python%{pyver}-devel
BuildRequires:    python%{pyver}-setuptools
BuildRequires:    python%{pyver}-pbr
BuildRequires:    python%{pyver}-six
BuildRequires:    python%{pyver}-oslo-i18n
BuildRequires:    python%{pyver}-oslo-utils
BuildRequires:    python%{pyver}-requests
BuildRequires:    python%{pyver}-glanceclient
BuildRequires:    python%{pyver}-keystoneclient
BuildRequires:    python%{pyver}-novaclient
BuildRequires:    python%{pyver}-cinderclient
BuildRequires:    python%{pyver}-mock
BuildRequires:    python%{pyver}-os-client-config
BuildRequires:    python%{pyver}-cliff
BuildRequires:    python%{pyver}-simplejson
%if %{pyver} == 2
BuildRequires:    python-requests-mock
%else
BuildRequires:    python%{pyver}-requests-mock
%endif

# Required to compile translation files
BuildRequires:    python%{pyver}-babel
# Required for unit tests
BuildRequires:    python%{pyver}-stestr
BuildRequires:    python%{pyver}-osc-lib-tests
BuildRequires:    python%{pyver}-fixtures
BuildRequires:    python%{pyver}-oslotest
BuildRequires:    python%{pyver}-reno
BuildRequires:    python%{pyver}-requestsexceptions
BuildRequires:    python%{pyver}-openstacksdk
BuildRequires:    python%{pyver}-osprofiler

Requires:         python%{pyver}-pbr
Requires:         python%{pyver}-babel
Requires:         python%{pyver}-openstacksdk >= 0.17.0
Requires:         python%{pyver}-oslo-i18n >= 3.15.3
Requires:         python%{pyver}-oslo-utils >= 3.33.0
Requires:         python%{pyver}-glanceclient >= 1:2.8.0
Requires:         python%{pyver}-keystoneauth1 >= 3.6.2
Requires:         python%{pyver}-keystoneclient >= 1:3.17.0
Requires:         python%{pyver}-novaclient >= 1:15.0.0
Requires:         python%{pyver}-cinderclient >= 3.3.0
Requires:         python%{pyver}-neutronclient >= 6.7.0
Requires:         python%{pyver}-six >= 1.10.0
Requires:         python%{pyver}-osc-lib >= 1.14.0
Requires:         python%{pyver}-cliff

Requires:         python-%{sname}-lang = %{version}-%{release}

%if 0%{?fedora} || 0%{?rhel} >= 8
# Dependency for auto-completion
Recommends:       bash-completion
%else
Requires:         bash-completion
%endif

%description -n python%{pyver}-%{sname}
%{common_desc}

%if 0%{?with_doc}
%package -n python-%{sname}-doc
Summary:          Documentation for OpenStack Command-line Client

BuildRequires:    python%{pyver}-sphinx
BuildRequires:    python%{pyver}-openstackdocstheme
BuildRequires:    python%{pyver}-sphinxcontrib-apidoc

Requires: python%{pyver}-%{sname} = %{version}-%{release}

%description -n python-%{sname}-doc
%{common_desc}

This package contains auto-generated documentation.
%endif

%package  -n python-%{sname}-lang
Summary:   Translation files for Openstackclient

%description -n python-%{sname}-lang
Translation files for Openstackclient

%prep
%autosetup -n %{name}-%{upstream_version} -S git

# We handle requirements ourselves, pkg_resources only bring pain
%py_req_cleanup

%build
%{pyver_build}

# Generate i18n files
%{pyver_bin} setup.py compile_catalog -d build/lib/%{sname}/locale

%install
%{pyver_install}

# Create a versioned binary for backwards compatibility until everything is pure py3
ln -s %{cname} %{buildroot}%{_bindir}/%{cname}-%{pyver}

%if 0%{?with_doc}
export PYTHONPATH=.
sphinx-build-%{pyver} -b html doc/source doc/build/html
sphinx-build-%{pyver} -b man doc/source doc/build/man
install -p -D -m 644 doc/build/man/%{cname}.1 %{buildroot}%{_mandir}/man1/%{cname}.1

# Fix hidden-file-or-dir warnings
rm -fr doc/build/html/.doctrees doc/build/html/.buildinfo doc/build/html/.htaccess
%endif

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{pyver_sitelib}/%{sname}/locale/*/LC_*/%{sname}*po
rm -f %{buildroot}%{pyver_sitelib}/%{sname}/locale/*pot
mv %{buildroot}%{pyver_sitelib}/%{sname}/locale %{buildroot}%{_datadir}/locale
rm -rf %{buildroot}%{pyver_sitelib}/%{sname}/locale

# Find language files
%find_lang %{sname} --all-name

%post -n python%{pyver}-%{sname}
mkdir -p /etc/bash_completion.d
openstack complete | sed -n '/_openstack/,$p' > /etc/bash_completion.d/osc.bash_completion

%check
export PYTHON=%{__python}
stestr-%{pyver} run

%files -n python%{pyver}-%{sname}
%license LICENSE
%doc README.rst
%{_bindir}/%{cname}
%{_bindir}/%{cname}-%{pyver}
%{pyver_sitelib}/%{sname}
%{pyver_sitelib}/*.egg-info
%if 0%{?with_doc}
%{_mandir}/man1/%{cname}.1*

%files -n python-%{sname}-doc
%license LICENSE
%doc doc/build/html
%endif

%files -n python-%{sname}-lang -f %{sname}.lang
%license LICENSE

%changelog
* Thu Nov 10 2022 Thierry Vignaud <tvignaud@redhat.com> 4.0.2-2.20220427020029
- Allow os quota list query to filter by project (rhbz#2074400)
- network: Make 'network qos rule create --type' option required (rhbz#2068189)

* Tue Apr 26 2022 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20220427020028.54bf2c0
- Fix 'server event list|show' for deleted servers (rhbz#2069412)
- Add bindep file (rhbz#2069412)

* Wed Mar 30 2022 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20220330134957.54bf2c0
- network: Make 'network qos rule create --type' option required (rhbz#2068189)

* Mon Jan 10 2022 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20220111042153.54bf2c0
- compute: Show flavor in 'server list' with API >= 2.47 (rhbz#2027879)
- compute: Reorder building of columns for 'server list' (rhbz#2027879)

* Mon Jul 19 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20210719124816.54bf2c0
- Update patches

* Mon Jul 19 2021 Slawek Kaplonski <skaplons@redhat.com> 4.0.2-2.20210711064809
- Fix reverted osc-lib interface change (rhbz#1978354)

* Sun Jul 11 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20210711064808.54bf2c0
- Update patches

* Fri Jul 09 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20210709064810.54bf2c0
- Update patches

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20210528091917.54bf2c0
- Update patches

* Mon May 10 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-2.20210510154810.54bf2c0
- compute: Add 'server group create --rule' option (rhbz#1945194)

* Wed Feb 10 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-1
- Add "fields" parameter to ListPort query (rhbz#1772106)

* Thu Feb 04 2021 OSP Prod Chain <dev-null@redhat.com> 4.0.2-1
- Update patches
- Add API check for server_groups.create
- Add API check for server_groups.list
- Bypass user and group verification in RemoveRole
- Add system role assignment tests for users and groups

* Thu Dec 17 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.1-1
- Update patches

* Mon Aug 17 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.1-1
- Update patches
- Client should parse string to boolean for value 'is_domain'
- Resolve PEP8
- Fix router create/show if extraroute not supported
- Stop silently ignoring invalid 'server create --hint' options
- Fix openstack server list --deleted --marker option
- Fix functional tests for py3
- Update TOX/UPPER_CONSTRAINTS_FILE for stable/train
- Update .gitreview for stable/train

* Mon Jul 20 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Wed Jul 15 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Tue Mar 10 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Wed Feb 19 2020 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Wed Feb 19 2020 Stephen Finucane <stephenfin@redhat.com> 4.0.0-0.20191025160015.aa64eb6
- Stop silently ignoring invalid 'server create --hint' options

* Fri Oct 25 2019 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Tue Sep 24 2019 OSP Prod Chain <dev-null@redhat.com> 4.0.0-1
- Update patches

* Mon Sep 23 2019 RDO <dev@lists.rdoproject.org> 4.0.0-1
- Update to 4.0.0


